/*-
 *  Copyright 2020 Beuth Hochschule für Technik Berlin, Hochschule für Technik Stuttgart
 * 
 *  This file is part of CityDoctor2.
 *
 *  CityDoctor2 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  CityDoctor2 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public License
 *  along with CityDoctor2.  If not, see <https://www.gnu.org/licenses/>.
 */
package de.hft.stuttgart.citydoctor2.check;

public class HealingID {
	
	public static final HealingID S_GEOMETRIC_SIMPLIFIER = new HealingID("S_GEOMETRIC_SIMPLIFIER");
	public static final HealingID S_ALL_POLYGONS_WRONG_ORIENTATION = new HealingID("S_ALL_POLYGONS_WRONG_ORIENTATION");
	public static final HealingID S_NON_MANIFOLD_EDGE = new HealingID("S_NON_MANIFOLD_EDGE");
	public static final HealingID S_POLYGON_WRONG_ORIENTATION = new HealingID("S_POLYGON_WRONG_ORIENTATION");
	public static final HealingID S_WRONG_DORMERS = new HealingID("S_WRONG_DORMERS");
	public static final HealingID R_CONSECUTIVE_POINTS_SAME = new HealingID("R_CONSECUTIVE_POINTS_SAME");
	public static final HealingID P_HOLE_OUTSIDE = new HealingID("P_HOLE_OUTSIDE");
	public static final HealingID SE_MISSING_LOD2_SOLID = new HealingID("SE_MISSING_LOD2_SOLID");
	public static final HealingID P_NON_PLANAR_POLYGON = new HealingID("P_NON_PLANAR_POLYGON");
	public static final HealingID R_NOT_CLOSED = new HealingID("R_NOT_CLOSED");
	public static final HealingID R_SELF_INTERSECTION = new HealingID("R_SELF_INTERSECTION");
	public static final HealingID P_SAME_ORIENTATION = new HealingID("P_SAME_ORIENTATION");
	public static final HealingID R_TOO_FEW_POINTS = new HealingID("R_TOO_FEW_POINTS");
	public static final HealingID S_NOT_CLOSED = new HealingID("S_NOT_CLOSED");
	public static final HealingID P_NON_PLANAR_POLYGON_CPP = new HealingID("P_NON_PLANAR_POLYGON_CPP");
	public static final HealingID S_NOT_CLOSED_CPP = new HealingID("S_NOT_CLOSED_CPP");
	
	private String idString;
	
	public HealingID(String idString) {
		this.idString = idString;
	}

	@Override
	public String toString() {
		return "HealingID [idString=" + idString + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((idString == null) ? 0 : idString.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		HealingID other = (HealingID) obj;
		if (idString == null) {
			if (other.idString != null)
				return false;
		} else if (!idString.equals(other.idString))
			return false;
		return true;
	}
	
	

}
